/*
 * Initialization.java
 *
 * Created on November 6, 2001, 3:17 PM
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/Initialization.java,v 1.4 2002/01/31 16:39:03 schmerl Exp $
 * $Log: Initialization.java,v $
 * Revision 1.4  2002/01/31 16:39:03  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.*;
import java.rmi.*;
import java.rmi.registry.*;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;


/**
 *
 * @author  hong
 * @version 
 */
public class Initialization {
    
    public static final int EVENTBUS_PORT = 1099;
    public static int busPort = 1099;
    //public static final int GAUGEMGR_PORT = 1199; 
    //public static final int GAUGE_PORT = 1299;    
    //public static final int GAUGECONSUMER_PORT = 1399;    
               
    /** Creates new Initialization */
    public Initialization() {
    }

    public static void startEventBus(int port) {
        try {
            RMIEventBus theEventBus;
            if (port != 0) busPort = port;
            Registry registry = LocateRegistry.createRegistry(busPort);             
            theEventBus = new RMIEventBus(busPort);
            registry.bind("RMIEventBus", theEventBus);
            System.out.println("RMIEventBus started");
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    
    public static String startGaugeMgrService(RMIGaugeMgr gaugeMgr) {    
        Registry registry = null;
        int p = 0;
        String host = "";
        try {
            p = Global.generatePort();
            try {
                registry = LocateRegistry.createRegistry(p);
            } catch (Exception e) {
                p = Global.generatePort();
                registry = LocateRegistry.createRegistry(p);
            }
            RMIGaugeMgrHandleImp theGaugeMgrHandleImp;
            theGaugeMgrHandleImp = new RMIGaugeMgrHandleImp(gaugeMgr);
            System.out.println("gaugeMgrType:"+gaugeMgr.getGaugeMgrType());
            registry.bind(gaugeMgr.gaugeMgrType, theGaugeMgrHandleImp);
            host = Global.getHost()+":"+Integer.toString(p);
            System.err.println("GaugeMgrService started at "+host);         
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        return host;
    }
    
    public static String startGaugeService(RMIGauge gauge) {    
        Registry registry = null;
        int p = 0;
        String host = "";
        try {
            p = Global.generatePort();
            try {
                registry = LocateRegistry.createRegistry(p);
            } catch (Exception e) {
                p = Global.generatePort();
                registry = LocateRegistry.createRegistry(p);
            }
            RMIGaugeHandleImp theGaugeHandleImp;
            theGaugeHandleImp = new RMIGaugeHandleImp(gauge);
            registry.bind("Gauge", theGaugeHandleImp);
            host = Global.getHost()+":"+Integer.toString(p);
            System.err.println("GaugeService started at "+host);            
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        return host;
    }
   
    public static int startGaugeConsumerService(RMIGaugeConsumer gaugeConsumer) {    
        try {
            RMIGaugeConsumerHandleImp theGaugeConsumerHandleImp;
            int p = Global.generatePort();
            Registry registry;
            try {
                registry = LocateRegistry.createRegistry(p);
            } catch (Exception e) {
                p = Global.generatePort();
                registry = LocateRegistry.createRegistry(p);
            }
            theGaugeConsumerHandleImp = new RMIGaugeConsumerHandleImp(gaugeConsumer);
            registry.bind("GaugeConsumer", theGaugeConsumerHandleImp);
            System.out.print("GaugeConsumerService started at port: ");
            System.out.println(p);
            return p;
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        return 0;
    }
    

    public static void main(String args[]) {
        int port = 0;
        if (args.length >= 1) {
            try {
                port = (new Integer(args[0])).intValue();
            }
            catch (Exception e) {port = 0;}
        }
        startEventBus(port);
    }
}
