/**
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIEventBusHandle.java,v 1.3 2002/01/31 16:39:03 schmerl Exp $
 * $Log: RMIEventBusHandle.java,v $
 * Revision 1.3  2002/01/31 16:39:03  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.RMI.Events.*;
/**
 * RMIEventBusHandle is the remote interface of RMIEventBus.
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 */
public interface RMIEventBusHandle extends java.rmi.Remote
{
    
    public void subscribeInterest(String gaugeConsumerUID, GaugeID theGaugeID, GaugeEventType gaugeEvent) throws java.rmi.RemoteException;
    public void registerGauge(GaugeID theGaugeID, StringPairVector setupParams, String gaugeHost) throws java.rmi.RemoteException;
    public void registerGaugeConsumer(String gaugeConsumerUID, String gaugeConsumerHost) throws java.rmi.RemoteException;
    public void registerGaugeMgr(String gaugeMgrHost, String gaugeMgrUID, String gaugeMgrType) throws java.rmi.RemoteException;
    public void configureGauge(GaugeID theGaugeID, StringPairVector configParams) throws java.rmi.RemoteException;
    public void deleteGauge(GaugeID theGaugeID) throws java.rmi.RemoteException;
    public void createGauge(GaugeID theGaugeID, StringPairVector setupParams, StringPairVector mappings) throws java.rmi.RemoteException;
    public String getGaugeHost(GaugeID gid) throws java.rmi.RemoteException;
    public String getGaugeMgr(String gaugeMgrType) throws java.rmi.RemoteException; 
    boolean reportValue(GaugeID gauge, String valueName, String propertyName, String value) throws java.rmi.RemoteException;
    public StringPairVector queryConfigMetaInfo(String gaugeType) throws java.rmi.RemoteException;
    public StringPairVector queryValueMetaInfo(String gaugeType) throws java.rmi.RemoteException;
    public boolean reportMultipleValues(GaugeID gauge, GaugeValueVector values) throws java.rmi.RemoteException;
    
    public boolean reportConfigured(GaugeID gauge, StringPairVector configParams) throws java.rmi.RemoteException;
    
    public boolean reportDeleted(GaugeID gauge) throws java.rmi.RemoteException;
    
    public boolean reportCreated(GaugeID gauge) throws java.rmi.RemoteException;
    
    public void subscribeToGaugeEvent(GaugeEvent event, Subscriber subscriber) throws java.rmi.RemoteException;
    
    public void unsubscribeToGaugeEvent(GaugeEvent event, Subscriber subscriber) throws java.rmi.RemoteException;
    
}
