/**
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIGaugeHandleImp.java,v 1.3 2002/01/31 16:39:04 schmerl Exp $
 * $Log: RMIGaugeHandleImp.java,v $
 * Revision 1.3  2002/01/31 16:39:04  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;
import java.util.Enumeration;
import java.rmi.*;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
/**
 * RMIGaugeHandleImp is the implementation of RMIGaugeHandle.
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 */
public class RMIGaugeHandleImp extends java.rmi.server.UnicastRemoteObject implements RMIGaugeHandleInt, java.io.Serializable
{
    private RMIGauge gauge;
    
    /** Creates new RMIGaugeHandleImp */
    public RMIGaugeHandleImp(RMIGauge gauge) throws java.rmi.RemoteException {
        super();
        this.gauge = gauge;
    }
    
    public RMIGauge getGauge() throws java.rmi.RemoteException
    {
        return gauge;
    }

    public GaugeID getGaugeID() throws java.rmi.RemoteException
    {
        return gauge.getGaugeID();
    }
    public int getConfigParamsSize() throws java.rmi.RemoteException
    {
        return gauge.getConfigParamsSize();
    }

    public StringPairVector getConfigParams() throws java.rmi.RemoteException
    {
        return gauge.getConfigParams();
    }

    public int getSetupParamsSize() throws java.rmi.RemoteException
    {
        return gauge.getSetupParamsSize();
    }

    public StringPairVector getSetupParams() throws java.rmi.RemoteException
    {
        return gauge.getSetupParams();
    }
    
    public boolean queryAllValues(GaugeValueVector values) throws java.rmi.RemoteException {
        return gauge.queryAllValues(values);
    }
    
    public boolean queryState(StringPairVector setupParams, StringPairVector configParams, StringPairVector mappings) throws java.rmi.RemoteException {
        return gauge.queryState(setupParams, configParams, mappings);
    }
    
    public String queryValue(String valueName) throws java.rmi.RemoteException {
        return gauge.queryValue(valueName);
        
    }

    public boolean configure(StringPairVector configParams) throws java.rmi.RemoteException {
        return gauge.configure(configParams);
    }
    
    public void delete() throws java.rmi.RemoteException
    {
        gauge.delete();
    }
    
    
}
