/**
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIGaugeMgrHandle.java,v 1.3 2002/01/31 16:39:05 schmerl Exp $
 * $Log: RMIGaugeMgrHandle.java,v $
 * Revision 1.3  2002/01/31 16:39:05  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
/**
 * RMIGaugeMgrHandle is a proxy gauge manager that acts as if it is the actual
 * gauge manager it refers to. It is used to hide the details of how to maintain the
 * peer-to-peer interaction between a local caller (or client) and a
 * remote callee (or server).
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 */
public interface RMIGaugeMgrHandle extends java.rmi.Remote
{
    public void createGauge(GaugeID theGaugeID, StringPairVector setupParams, StringPairVector mappings, String gaugeMgrHost, String eventBusHost) throws java.rmi.RemoteException;
    
    public void configureGauge(GaugeID theGaugeID, StringPairVector configParams) throws java.rmi.RemoteException;  
    
    public String getGaugeMgrUID() throws java.rmi.RemoteException; 
    
    public GaugeControl createGauge(GaugeID gauge, StringPairVector setupParams, StringPairVector mappings) throws java.rmi.RemoteException;
    
    public boolean managesType(String gaugeType) throws java.rmi.RemoteException;
    
    public boolean deleteGauge(GaugeControl gauge) throws java.rmi.RemoteException;
    
    public StringPairVector queryConfigMetaInfo(String gaugeType) throws java.rmi.RemoteException;
    public StringPairVector queryValueMetaInfo(String gaugeType) throws java.rmi.RemoteException;       
}
